#!/usr/bin/python
import os, sys, string

# need to change these paremeters depends on the expected coverage and heterozygosity level of the genome
COV_CUTOFF = 41 # cutoff for coverage significantly lower than the expected one (98% confidence)
IDEN_CUTOFF = 90 # cutoff for identity between merged scaffolds

scaflens = {}
scafranks = {}
fp = open(sys.argv[1],"r")
info = fp.readlines()
fp.close()
goodscafs = []
badscafs = []
for line in info:
	words = line.split()
        if int(words[1]) < 1000 and float(words[2]) < COV_CUTOFF:
		badscafs.append(words[0])
		scaflens[words[0]] = int(words[1])
	else:
		goodscafs.append(words[0])
info = ""
goodones = set(goodscafs)
badones = set(badscafs)

scafmaps = {}
fp = open(sys.argv[2],"r")
for line in fp:
	words = line.split()
	if words[0] != words[1] and words[0] in badones and words[1] in goodones and float(words[2]) > IDEN_CUTOFF:
		try:
			scafmaps[words[0]]
			try:
				scafmaps[words[0]][words[1]]
				scafmaps[words[0]][words[1]] = scafmaps[words[0]][words[1]].union(set(range(int(words[5]),int(words[6])+1)))
			except KeyError:
				scafmaps[words[0]][words[1]] = set(range(int(words[5]),int(words[6])+1))
		except KeyError:
			scafmaps[words[0]] = {}
			scafmaps[words[0]][words[1]] = set(range(int(words[5]),int(words[6])+1))

rp = open("to_remove_2","w")
for scaf in badscafs:
	try:
		scafmaps[scaf]
		covered = set([])
		for scaf2 in scafmaps[scaf]:
			covered = covered.union(scafmaps[scaf][scaf2])
		if len(covered) > scaflens[scaf] * 0.9 and (scaflens[scaf] - len(covered)) < 200:
			rp.write(scaf + "\n")
		elif (scaflens[scaf] - len(covered)) < 100 and len(covered) > scaflens[scaf] * 0.6:
			rp.write(scaf + "\n")
		elif (scaflens[scaf] - len(covered)) < 50:
                        rp.write(scaf + "\n")
	except KeyError:
		pass
	
